//
// Copyright (C) 1999-2002 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#ifndef	WSDFILESYSTEM_H
#define	WSDFILESYSTEM_H

#include <WScom.h>
class WSClistData;

#define WS_FS_FILE  1
#define WS_FS_DIR   2
#define WS_FS_READONLY 4

#ifdef MacOS
#undef check
#endif //MacOS

class WSDfileSystem{

  public:
    WSDfileSystem();
    virtual ~WSDfileSystem();

    virtual char* adjustFileName(char*);
    virtual long  rename(char*,char*);
    virtual long  deleteFile(char*);
    virtual long  createDir(char*);
    virtual long  deleteDir(char*);
    virtual long  check(char*);
    virtual WSClistData*  showNetDir(char*,char*); //need delete list and items...
    virtual WSClistData*  showDir(char*); //need delete list and items...
    virtual WSClistData*  showFile(char*);//need delete list and items...

    static  void setCreateInstanceHandler( WSDfileSystem* (*hd)() );
};
extern WSDLEX WSDfileSystem* WSGIappFileSystem();
#endif
